#ifndef _H_96A92ACD5325E8BB50736844EB16552F_IMUInfo_DCPS_H_
#define _H_96A92ACD5325E8BB50736844EB16552F_IMUInfo_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "IMUInfo_.h"


namespace realsense_camera_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class IMUInfo_TypeSupportInterface;

            typedef IMUInfo_TypeSupportInterface * IMUInfo_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < IMUInfo_TypeSupportInterface> IMUInfo_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < IMUInfo_TypeSupportInterface> IMUInfo_TypeSupportInterface_out;


            class IMUInfo_DataWriter;

            typedef IMUInfo_DataWriter * IMUInfo_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < IMUInfo_DataWriter> IMUInfo_DataWriter_var;
            typedef DDS_DCPSInterface_out < IMUInfo_DataWriter> IMUInfo_DataWriter_out;


            class IMUInfo_DataReader;

            typedef IMUInfo_DataReader * IMUInfo_DataReader_ptr;
            typedef DDS_DCPSInterface_var < IMUInfo_DataReader> IMUInfo_DataReader_var;
            typedef DDS_DCPSInterface_out < IMUInfo_DataReader> IMUInfo_DataReader_out;


            class IMUInfo_DataReaderView;

            typedef IMUInfo_DataReaderView * IMUInfo_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < IMUInfo_DataReaderView> IMUInfo_DataReaderView_var;
            typedef DDS_DCPSInterface_out < IMUInfo_DataReaderView> IMUInfo_DataReaderView_out;

            struct IMUInfo_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < IMUInfo_, struct IMUInfo_Seq_uniq_> IMUInfo_Seq;
            typedef DDS_DCPSSequence_var < IMUInfo_Seq> IMUInfo_Seq_var;
            typedef DDS_DCPSSequence_out < IMUInfo_Seq> IMUInfo_Seq_out;

            class  IMUInfo_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef IMUInfo_TypeSupportInterface_ptr _ptr_type;
                typedef IMUInfo_TypeSupportInterface_var _var_type;

                static IMUInfo_TypeSupportInterface_ptr _duplicate (IMUInfo_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IMUInfo_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static IMUInfo_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IMUInfo_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                IMUInfo_TypeSupportInterface_ptr _this () { return this; }


            protected:
                IMUInfo_TypeSupportInterface () {};
                ~IMUInfo_TypeSupportInterface () {};
            private:
                IMUInfo_TypeSupportInterface (const IMUInfo_TypeSupportInterface &);
                IMUInfo_TypeSupportInterface & operator = (const IMUInfo_TypeSupportInterface &);
            };

            class  IMUInfo_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef IMUInfo_DataWriter_ptr _ptr_type;
                typedef IMUInfo_DataWriter_var _var_type;

                static IMUInfo_DataWriter_ptr _duplicate (IMUInfo_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IMUInfo_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static IMUInfo_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IMUInfo_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                IMUInfo_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const IMUInfo_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const IMUInfo_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const IMUInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const IMUInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const IMUInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const IMUInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const IMUInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const IMUInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const IMUInfo_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const IMUInfo_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (IMUInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IMUInfo_& instance_data) = 0;

            protected:
                IMUInfo_DataWriter () {};
                ~IMUInfo_DataWriter () {};
            private:
                IMUInfo_DataWriter (const IMUInfo_DataWriter &);
                IMUInfo_DataWriter & operator = (const IMUInfo_DataWriter &);
            };

            class  IMUInfo_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef IMUInfo_DataReader_ptr _ptr_type;
                typedef IMUInfo_DataReader_var _var_type;

                static IMUInfo_DataReader_ptr _duplicate (IMUInfo_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IMUInfo_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static IMUInfo_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IMUInfo_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                IMUInfo_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IMUInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IMUInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IMUInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IMUInfo_& instance) = 0;

            protected:
                IMUInfo_DataReader () {};
                ~IMUInfo_DataReader () {};
            private:
                IMUInfo_DataReader (const IMUInfo_DataReader &);
                IMUInfo_DataReader & operator = (const IMUInfo_DataReader &);
            };

            class  IMUInfo_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef IMUInfo_DataReaderView_ptr _ptr_type;
                typedef IMUInfo_DataReaderView_var _var_type;

                static IMUInfo_DataReaderView_ptr _duplicate (IMUInfo_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IMUInfo_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static IMUInfo_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IMUInfo_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                IMUInfo_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IMUInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IMUInfo_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IMUInfo_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IMUInfo_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IMUInfo_& instance) = 0;

            protected:
                IMUInfo_DataReaderView () {};
                ~IMUInfo_DataReaderView () {};
            private:
                IMUInfo_DataReaderView (const IMUInfo_DataReaderView &);
                IMUInfo_DataReaderView & operator = (const IMUInfo_DataReaderView &);
            };
        }

    }

}

#endif
